

using System;
using IRaCIS.Core.Domain.Share;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    ///<summary>
    /// 一致性分析临床数据
    ///</summary>
    [Table("ReadingConsistentClinicalDataPDF")]
	public class ReadingConsistentClinicalDataPDF : Entity, IAuditAdd
	{
		[JsonIgnore]
		[ForeignKey("ReadingConsistentClinicalDataId")]
		public ReadingConsistentClinicalData ReadingConsistentClinicalData { get; set; }
		/// <summary>
		/// 阅片临床数据ID
		/// </summary>
		public Guid ReadingConsistentClinicalDataId { get; set; }

		/// <summary>
		/// Path
		/// </summary>
		[Required]
		public string Path { get; set; }

		/// <summary>
		/// FileName
		/// </summary>
		[Required]
		public string FileName { get; set; }


		/// <summary>
		/// 创建时间
		/// </summary>
		public DateTime CreateTime { get; set; }

		/// <summary>
		/// 创建人
		/// </summary>
		public Guid CreateUserId { get; set; }

        /// <summary>
        /// 大小
        /// </summary>
        public int Size { get; set; } = 0;

        /// <summary>
        /// 文件类型
        /// </summary>
        public string Type { get; set; }


    }


	



}
